"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UsageGraphError = exports.NotFoundGraphError = exports.InvalidArgumentsGraphError = exports.GraphError = void 0;

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

function _wrapNativeSuper(Class) { var _cache = typeof Map === "function" ? new Map() : undefined; _wrapNativeSuper = function _wrapNativeSuper(Class) { if (Class === null || !_isNativeFunction(Class)) return Class; if (typeof Class !== "function") { throw new TypeError("Super expression must either be null or a function"); } if (typeof _cache !== "undefined") { if (_cache.has(Class)) return _cache.get(Class); _cache.set(Class, Wrapper); } function Wrapper() { return _construct(Class, arguments, _getPrototypeOf(this).constructor); } Wrapper.prototype = Object.create(Class.prototype, { constructor: { value: Wrapper, enumerable: false, writable: true, configurable: true } }); return _setPrototypeOf(Wrapper, Class); }; return _wrapNativeSuper(Class); }

function isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _construct(Parent, args, Class) { if (isNativeReflectConstruct()) { _construct = Reflect.construct; } else { _construct = function _construct(Parent, args, Class) { var a = [null]; a.push.apply(a, args); var Constructor = Function.bind.apply(Parent, a); var instance = new Constructor(); if (Class) _setPrototypeOf(instance, Class.prototype); return instance; }; } return _construct.apply(null, arguments); }

function _isNativeFunction(fn) { return Function.toString.call(fn).indexOf("[native code]") !== -1; }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

/**
 * Graphology Custom Errors
 * =========================
 *
 * Defining custom errors for ease of use & easy unit tests across
 * implementations (normalized typology rather than relying on error
 * messages to check whether the correct error was found).
 */
var GraphError =
/*#__PURE__*/
function (_Error) {
  _inheritsLoose(GraphError, _Error);

  function GraphError(message, data) {
    var _this;

    _this = _Error.call(this) || this;
    _this.name = 'GraphError';
    _this.message = message || '';
    _this.data = data || {};
    return _this;
  }

  return GraphError;
}(_wrapNativeSuper(Error));

exports.GraphError = GraphError;

var InvalidArgumentsGraphError =
/*#__PURE__*/
function (_GraphError) {
  _inheritsLoose(InvalidArgumentsGraphError, _GraphError);

  function InvalidArgumentsGraphError(message, data) {
    var _this2;

    _this2 = _GraphError.call(this, message, data) || this;
    _this2.name = 'InvalidArgumentsGraphError'; // This is V8 specific to enhance stack readability

    if (typeof Error.captureStackTrace === 'function') Error.captureStackTrace(_assertThisInitialized(_this2), InvalidArgumentsGraphError.prototype.constructor);
    return _this2;
  }

  return InvalidArgumentsGraphError;
}(GraphError);

exports.InvalidArgumentsGraphError = InvalidArgumentsGraphError;

var NotFoundGraphError =
/*#__PURE__*/
function (_GraphError2) {
  _inheritsLoose(NotFoundGraphError, _GraphError2);

  function NotFoundGraphError(message, data) {
    var _this3;

    _this3 = _GraphError2.call(this, message, data) || this;
    _this3.name = 'NotFoundGraphError'; // This is V8 specific to enhance stack readability

    if (typeof Error.captureStackTrace === 'function') Error.captureStackTrace(_assertThisInitialized(_this3), NotFoundGraphError.prototype.constructor);
    return _this3;
  }

  return NotFoundGraphError;
}(GraphError);

exports.NotFoundGraphError = NotFoundGraphError;

var UsageGraphError =
/*#__PURE__*/
function (_GraphError3) {
  _inheritsLoose(UsageGraphError, _GraphError3);

  function UsageGraphError(message, data) {
    var _this4;

    _this4 = _GraphError3.call(this, message, data) || this;
    _this4.name = 'UsageGraphError'; // This is V8 specific to enhance stack readability

    if (typeof Error.captureStackTrace === 'function') Error.captureStackTrace(_assertThisInitialized(_this4), UsageGraphError.prototype.constructor);
    return _this4;
  }

  return UsageGraphError;
}(GraphError);

exports.UsageGraphError = UsageGraphError;